#include "Init_SPI.h"

void SPI1_SendByte(uint8_t byte)
{
	while(!(SPI1->SR & SPI_SR_TXE));
    SPI1->DR=byte;
}
//==============================================================================
void  SPI1_WR_String(const char *s)
{ int i = 0;
 while (s [i] != 0) {
	SPI1_SendByte (s[i++]);
	}
}
//==============================================================================
uint8_t SPI1_ReadByte(uint8_t byte)
{
//  while (!(SPI1->SR & SPI_SR_TXE));
  SPI1->DR=byte;
  while (!(SPI1->SR & SPI_SR_RXNE));
  return (SPI1->DR);
}

void SPI_ini(void)
{
   GPIO_InitTypeDef  GPIO_InitStructure;
   SPI_InitTypeDef   SPI_user;
   
   RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOA, ENABLE);//5,6,7
   RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOB, ENABLE);
   
   /* TIM1 channel 2 pin (PE.11) configuration */
  GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_5 | GPIO_Pin_6 | GPIO_Pin_7;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
  GPIO_Init(GPIOA, &GPIO_InitStructure);
   
   //for ssd1306 CS,REC,DC
  GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_0 | GPIO_Pin_1 | GPIO_Pin_2;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_Init(GPIOB, &GPIO_InitStructure);

  /* Connect TIM pins to AF2 */
  GPIO_PinAFConfig(GPIOA, GPIO_PinSource5, GPIO_AF_0);
  GPIO_PinAFConfig(GPIOA, GPIO_PinSource6, GPIO_AF_0);
  GPIO_PinAFConfig(GPIOA, GPIO_PinSource7, GPIO_AF_0);
   
  CS_OFF;
  
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_SPI1, ENABLE);
   
//  SPI_user.SPI_Direction = SPI_Direction_1Line_Tx;
//  SPI_user.SPI_Mode = SPI_Mode_Master;
//  SPI_user.SPI_DataSize = SPI_DataSize_8b;
//  SPI_user.SPI_CPOL = SPI_CPOL_High;
//  SPI_user.SPI_CPHA = SPI_CPHA_2Edge;
//  SPI_user.SPI_NSS = SPI_NSS_Soft;
//  SPI_user.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_128;
//  SPI_user.SPI_FirstBit = SPI_FirstBit_MSB;
//  SPI_user.SPI_CRCPolynomial = 7;
//  
//  SPI_Init(SPI1, &SPI_user);
//  SPI_Cmd(SPI1, ENABLE);
  
  SPI1->CR1 |= SPI_CR1_BIDIMODE  //1-line bidirectional data mode selected
            | SPI_CR1_BIDIOE     //Output enabled (transmit-only mode)
            | SPI_CR1_SSM                //Software slave management enabled
            | SPI_CR1_SSI                //  SSM    1
            | SPI_CR1_SPE                //SPI enable
            | SPI_CR1_BR_2 | SPI_CR1_BR_1 // 128 
            | SPI_CR1_MSTR               //Master configuration
            | SPI_CR1_CPOL               // Clock polarity to 1 when idle
            | SPI_CR1_CPHA;              // Clock phase The second clock
   
  SPI1->CR2 |= SPI_CR2_DS_2 | SPI_CR2_DS_1 | SPI_CR2_DS_0; //8-bit
            
}

