#include "SSD1306_SPI.h"
#include "Init_SPI.h"
#include "stm32f0xx.h"

 uint8_t LCD_X,LCD_Y;

void LCD_Reset(void)
{
uint32_t i; //    
//	CS_low;
	for(i=0; i<0x00000FFF; i++);  //
	Reset_low;						//Reset Slave
	for(i=0; i<0x000FFFFF; i++);  //
	Reset_high;						//Normal Working
	for(i=0; i<0x0000FFFF; i++);  //
//	CS_high
}
//==============================================================================
void send_command(uint8_t byte_to_send)
{
   CS_ON;
	if (GPIOB->IDR & GPIO_IDR_1)				//  , 
	{
		while (SPI1->SR & SPI_SR_BSY);			//  
		wr_Command;								//  ""
	}
	SPI1_SendByte(byte_to_send);
   CS_OFF;
}	
//==============================================================================
void send_data(uint8_t byte_to_send)
{
   CS_ON;
	if (!(GPIOB->IDR & GPIO_IDR_1))		//  , 
	{
		while (SPI1->SR & SPI_SR_BSY);			//  
		wr_Data;								//  ""
	}
	SPI1_SendByte(byte_to_send);
   CS_OFF;
}
//==============================================================================
void LCD_Goto(uint8_t x, uint8_t y)
{
	LCD_X = x;
	LCD_Y = y;
	// send a bunch of data in one xmission
	send_command(x & 0xf);//set lower column address
	send_command(0x10 | (x >> 4));//set higher column address
	send_command(0xB0 + y);//set page address
}
//==============================================================================
void Fill_RAM(unsigned char Data)
{
	uint8_t i,j;
		for(i=0;i<LCDHEIGHT/8;i++)
		{
			LCD_Goto(0, i);
			for(j=0;j<LCDWIDTH;j++)
			{
				send_data(Data);
			}
		}
}
//==============================================================================
uint8_t LCD_Init_sequence[24] = 
{
0xAF,     // Display Off** 0xAE

0xD5,     // clock
0x80,     // upper nibble is rate, lower nibble is divisor***

0xA8,     // Set multiplex ratio
0x3F,     // rtfm

0xD3,     // Set Display Offset 0xD3
0x00,     // no offset

0x40,     // Set display start line

0x8D,     // Set charge pump
0x14,     // 0x10 - Suplied Externally

0xA1,     // Segrment remap - 0xA1 (A0->SEG0=column0, A1->SEG0=column127)

0xC8,     // Set COM output scan Direction (C0=up, C8=down)

0xDA,     // Seet COM pins hardware configuration
0x12,     //  bits [5],[4] & b1=1
	
0x81,     // Set Contrast 0x81
0xCF,     // 0x9F - Suplied Externally (CF)
	
0xD9,     // Set Pre-Charge period
0xF1,     // 0x22 - Suplied Externally
	
0xDB,     // Set VCOMH Deselect Level
0x70,     // 
	
0xA4,     // Set entire DISPLAY on/off
	
0xA6,     // Normal Display 0xA6 (Invert A7)
	
0x20,     // Set Memory Addressing Mode
0x02     // Default => 0x02
};
void LCD_init(void)
{
	uint8_t x;
//	RCC->APB2ENR |= RCC_APB2ENR_IOPAEN; //  A
////#ifdef	wr_Data
//	GPIOA->CRL |= GPIO_CRL_MODE3; // PA3  A   
//	GPIOA->CRL &= ~GPIO_CRL_CNF3_0; // Push-Pull   PA3  A
////#endif
////#ifdef	Reset_high
//	GPIOA->CRL |= GPIO_CRL_MODE2; // PA2  A   
//	GPIOA->CRL &= ~GPIO_CRL_CNF2_0; // Push-Pull   PA2  A
//#endif
//	CS_low;
   
	for (x=0; x<24; x++)
		{
			send_command(LCD_Init_sequence[x]);
		}
	Fill_RAM(0xff);             // Clear Screen
		send_command(0xAF);     // Display On

//	CS_high;
}



