#ifndef Init_SSD1306_SPI_H
#define Init_SSD1306_SPI_H

#include "stm32f0xx.h" 
#include "stm32f0xx_gpio.h"

#define LCDWIDTH                  	128
#define LCDHEIGHT                 	64

#define CS_ON     GPIO_ResetBits(GPIOB, GPIO_Pin_2)
#define CS_OFF    GPIO_SetBits(GPIOB, GPIO_Pin_2)

//Reset Slave - pin PB0
#define Reset_high		GPIO_SetBits(GPIOB, GPIO_Pin_0)		// Set bit 0, Normal Working
#define Reset_low		   GPIO_ResetBits(GPIOB, GPIO_Pin_0)		// Reset bit 0, Reset Slave

//Command/Data select - pin PB1
#define wr_Data			GPIO_SetBits(GPIOB, GPIO_Pin_1)		// Set bit 1, Write Data
#define wr_Command		GPIO_ResetBits(GPIOB, GPIO_Pin_1)		// Reset bit 1, Write Command


void LCD_Reset(void);
void send_command(uint8_t byte_to_send);
void send_data(uint8_t byte_to_send);
void Fill_RAM(uint8_t Data);
void LCD_Goto(uint8_t x, uint8_t y);

void LCD_init(void);

#endif

